// Generated by CoffeeScript 1.6.3
/* Copyright Information
	# @author	Tim Düsterhus
	# @copyright	2012-2013 Tim Düsterhus
	# @license	BSD 3-Clause License <http://opensource.org/licenses/BSD-3-Clause>
	# @package	be.bastelstu.wcf.nodePush
*/


(function() {
  (function($, window) {
    "use strict";
    var connected, console, events, init, initialized, onConnect, onDisconnect, onMessage, socket, _base;
    console = {
      log: function(message) {
        return window.console.log("[be.bastelstu.wcf.nodePush] " + message);
      },
      warn: function(message) {
        return window.console.warn("[be.bastelstu.wcf.nodePush] " + message);
      },
      error: function(message) {
        return window.console.error("[be.bastelstu.wcf.nodePush] " + message);
      }
    };
    socket = null;
    connected = false;
    initialized = false;
    events = {
      connect: $.Callbacks(),
      disconnect: $.Callbacks(),
      message: {}
    };
    init = function(host) {
      if (initialized) {
        return;
      }
      initialized = true;
      console.log('Initializing nodePush');
      if (window.io == null) {
        console.error('nodePush not available, aborting');
        return;
      }
      socket = window.io.connect(host);
      socket.on('connect', function() {
        console.log('Connected to nodePush');
        return socket.emit('userID', WCF.User.userID);
      });
      socket.on('authenticated', function() {
        console.log('Exchanged userID with nodePush');
        connected = true;
        return events.connect.fire();
      });
      socket.on('disconnect', function() {
        connected = false;
        console.warn('Lost connection to nodePush');
        return events.disconnect.fire();
      });
      return socket.on('message', function(message) {
        if (events.message[message] == null) {
          return;
        }
        return events.message[message].fire();
      });
    };
    onConnect = function(callback) {
      if (!$.isFunction(callback)) {
        return false;
      }
      events.connect.add(callback);
      if (connected) {
        callback();
      }
      return true;
    };
    onDisconnect = function(callback) {
      if (!$.isFunction(callback)) {
        return false;
      }
      events.disconnect.add(callback);
      return true;
    };
    onMessage = function(message, callback) {
      var _base;
      if (!$.isFunction(callback)) {
        return false;
      }
      if (!/^[a-zA-Z0-9-_]+\.[a-zA-Z0-9-_]+(\.[a-zA-Z0-9-_]+)+$/.test(message)) {
        return false;
      }
      if ((_base = events.message)[message] == null) {
        _base[message] = $.Callbacks();
      }
      events.message[message].add(callback);
      return true;
    };
    if (window.be == null) {
      window.be = {};
    }
    if (be.bastelstu == null) {
      be.bastelstu = {};
    }
    if ((_base = be.bastelstu).wcf == null) {
      _base.wcf = {};
    }
    return be.bastelstu.wcf.nodePush = {
      init: init,
      onConnect: onConnect,
      onDisconnect: onDisconnect,
      onMessage: onMessage
    };
  })(jQuery, this);

}).call(this);
